Index: ultimate_cart/veronica/FT832.v
===================================================================
--- ultimate_cart/veronica/FT832.v	(revision 684)
+++ ultimate_cart/veronica/FT832.v	(revision 685)
@@ -4883,15 +4866,7 @@
                 if (s16|s32) begin
                     mlb <= 1'b1;
                     wadr <= inc_adr(wadr);
-                    if (DEAD_CYCLE) begin
-                        data_nack();
-                        next_state(STORE1);
-                    end
-                    else begin
-                        data_write(inc_adr(wadr),x[15:8],0);
-                        if (seg_fault_val==0)
-                            next_state(STORE2);
-                    end
+                    next_state(STORE1);
                     store_what <= `STW_X158;
     			end
 			end
@@ -4901,15 +4876,7 @@
                 if (s32) begin
                     mlb <= 1'b1;
                     wadr <= inc_adr(wadr);
-                    if (DEAD_CYCLE) begin
-                        data_nack();
-                        next_state(STORE1);
-                    end
-                    else begin
-                        data_write(inc_adr(wadr),x[23:16],0);
-                        if (seg_fault_val==0)
-                            state <= STORE2;
-                    end
+                    next_state(STORE1);
                     store_what <= `STW_X2316;
                 end
             end          
@@ -4919,15 +4886,7 @@
                 do_fill_inc(MVN816);
                 mlb <= 1'b1;
                 wadr <= inc_adr(wadr);
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-		            data_write(inc_adr(wadr),x[31:24],0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
                 store_what <= `STW_X3124;
             end
         `STW_X3124:
@@ -4937,15 +4896,7 @@
 			if (s16|s32) begin
 				mlb <= 1'b1;
 				wadr <= inc_adr(wadr);
-				if (DEAD_CYCLE) begin
-                    data_nack();
-				    next_state(STORE1);
-				end
-				else begin
-                    data_write(inc_adr(wadr),y[15:8],0);
-                    if (seg_fault_val==0)
-    		  	   	   state <= STORE2;
-    		    end
+    		    next_state(STORE1);
 				store_what <= `STW_Y158;
 			end
 		`STW_Y158:
@@ -4952,15 +4903,7 @@
             if (s32) begin
                 mlb <= 1'b1;
                 wadr <= inc_adr(wadr);
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-                    data_write(inc_adr(wadr),y[23:16],0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
                 store_what <= `STW_Y2316;
             end
 		`STW_Y2316:
@@ -4967,15 +4910,7 @@
             begin
                 mlb <= 1'b1;
                 wadr <= inc_adr(wadr);
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-                    data_write(inc_adr(wadr),y[31:24],0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
                 store_what <= `STW_Y3124;
             end
 		`STW_Z70:
@@ -4982,15 +4917,7 @@
 			if (s16|s32) begin
 				mlb <= 1'b1;
 				wadr <= inc_adr(wadr);
-				if (DEAD_CYCLE) begin
-                    data_nack();
-				    next_state(STORE1);
-				end
-				else begin
-                    data_write(inc_adr(wadr),8'h00,0);
-                    if (seg_fault_val==0)
-			     	    state <= STORE2;
-				end
+    		    next_state(STORE1);
 				store_what <= `STW_Z158;
 			end
 		`STW_Z158:
@@ -4997,15 +4924,7 @@
             if (s32) begin
                 mlb <= 1'b1;
                 wadr <= inc_adr(wadr);
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-                    data_write(inc_adr(wadr),8'h00,0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
                 store_what <= `STW_Z2316;
             end
 		`STW_Z2316:
@@ -5012,15 +4931,7 @@
             begin
                 mlb <= 1'b1;
                 wadr <= inc_adr(wadr);
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-                    data_write(inc_adr(wadr),8'h00,0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
                 store_what <= `STW_Z3124;
             end
 		`STW_DPR70:
@@ -5031,20 +4942,11 @@
 				state <= STORE1;
 			end
 `ifdef SUPPORT_TASK
-`ifndef TASK_BL
 		`STW_TR158:
             begin
                 mlb <= `TRUE;
                 set_sp();
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-                    data_write(fn_get_sp(sp),otr[7:0],0);
-                    if (seg_fault_val==0)
-                        next_state(STORE2);
-                end
+                next_state(STORE1);
                 store_what <= `STW_TR70;
             end
         `STW_TR70:
@@ -5052,21 +4954,12 @@
                 moveto_ifetch();
             end
 `endif
-`endif
 `ifdef SUPPORT_SEG
 		`STW_DS70:
 		    begin
 				mlb <= 1'b1;
 				wadr <= inc_adr(wadr);
-				if (DEAD_CYCLE) begin
-                    data_nack();
-				    next_state(STORE1);
-				end
-				else begin
-				    data_write(inc_adr(wadr),ds[15:8],0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+    		    next_state(STORE1);
                 store_what <= `STW_DS158;
 		    end
         `STW_CS158:
@@ -5073,15 +4966,7 @@
             begin
 			    mlb <= TRUE;
                 set_sp();
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-                    data_write(fn_get_sp(sp),cs[7:0],0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
                 store_what <= `STW_CS70;
             end
         `STW_CS70:
@@ -5088,15 +4973,7 @@
             if (ir9 != `PHCS) begin
 			    mlb <= TRUE;
                 set_sp();
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-                    data_write(fn_get_sp(sp),pc[23:16],0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
                 store_what <= `STW_PC2316;
             end
 `endif
@@ -5129,15 +5006,7 @@
 				if (ir9 != `PHK) begin
     			    mlb <= TRUE;
 					set_sp();
-					if (DEAD_CYCLE) begin
-                        data_nack();
-		 			    next_state(STORE1);
-					end
-					else begin
-                        data_write(fn_get_sp(sp),pc[15:8],0);
-                        if (seg_fault_val==0)
-                            state <= STORE2;
-    			    end
+     			    next_state(STORE1);
 					store_what <= `STW_PC158;
 				end
 			end
@@ -5145,15 +5014,7 @@
 			begin
 			    mlb <= TRUE;
 				set_sp();
-				if (DEAD_CYCLE) begin
-                    data_nack();
-				    next_state(STORE1);
-				end
-				else begin
-                    data_write(fn_get_sp(sp),pc[7:0],0);
-                    if (seg_fault_val==0)
-    		      		state <= STORE2;
-    		    end
+    		    next_state(STORE1);
 				store_what <= `STW_PC70;
 			end
 		`STW_PC70:
@@ -5163,15 +5024,7 @@
 						begin
         			    mlb <= TRUE;
 						set_sp();
-						if (DEAD_CYCLE) begin
-                            data_nack();
-						    next_state(STORE1);
-						end
-						else begin
-                            data_write(fn_get_sp(sp),sr8,0);
-                            if (seg_fault_val==0)
-    				    		state <= STORE2;
-    				    end
+    				    next_state(STORE1);
 					    store_what <= `STW_SR70;
 						end
 				`JSR:
@@ -5181,15 +5034,22 @@
 				`JSL:
 				    	begin
                         pc[23:0] <= ir[31:8];
+                        next_state(PBDELAY);
 						end
 			     `BSR:   pc[15:0] <= pc[15:0] + ir[23:8] + 16'd1;
-			     `BSL:   pc <= pc + ir[31:8] + 24'd1;
+			     `BSL:   begin
+			             pc <= pc + ir[31:8] + 24'd1;
+			             next_state(PBDELAY);
+			             end
 `ifdef SUPPORT_SEG
 			    `JSF,`JCF:
 			            begin
     		            pc <= ir[31:8];
+`ifdef SUPPORT_SEG    		            
                         cs <= ir[47:32];
+                        mapno <= ir[37:32];
                         sdt_ra <= ir[47:32];
+`endif                        
                         next_state(JMF1);
 		                end
 `endif
@@ -5197,9 +5057,11 @@
 						begin
 						state <= LOAD_MAC1;
 						load_what <= `PC_70;
+`ifdef SUPPORT_SEG					
 						seg <= ds_base;
                         lmt <= ds_limit;
                         mem_wr <= ds_wr;
+`endif                 
 						radr <= absx_address;
 						bank_wrap <= FALSE;
 						page_wrap <= FALSE;
@@ -5208,9 +5070,11 @@
                         begin
                         state <= LOAD_MAC1;
                         load_what <= `PC_70;
+`ifdef SUPPORT_SEG
                         seg <= ds_base;
                         lmt <= ds_limit;
                         mem_wr <= ds_wr;
+`endif
                         radr <= xalx_address;
 						bank_wrap <= FALSE;
                         page_wrap <= FALSE;
@@ -5221,69 +5085,23 @@
 		    begin
 		        store_what <= `STW_SR70;
 				set_sp();
-                if (DEAD_CYCLE) begin
-                    data_nack();
-                    next_state(STORE1);
-                end
-                else begin
-                    data_write(fn_get_sp(sp),sr8,0);
-                    if (seg_fault_val==0)
-                        state <= STORE2;
-                end
+                next_state(STORE1);
 		    end
         `STW_SR70:
 			begin
 				if (ir[7:0]==`BRK) begin
-					load_what <= `PC_70;
-					seg <= 32'd0;
-                    lmt <= 32'hFFFF;
-                    mem_wr <= FALSE;
-					state <= LOAD_MAC1;
-					pc[23:16] <= 8'h00;//abs8[23:16];
-					radr <= vect;
-					vpb <= TRUE;
-//					data_read(vect);
-					im <= hwi;
+					pc <= {8'h00,temp_vec};//abs8[23:16];
 					df <= 1'b0;
 					bank_wrap <= FALSE;
                     page_wrap <= FALSE;
 				end
 				else if (ir[7:0]==`COP) begin
-					load_what <= `PC_70;
-					seg <= 32'd0;
-					lmt <= 32'hFFFF;
-					mem_wr <= FALSE;
-					state <= LOAD_MAC1;
-					pc[23:16] <= 8'h00;//abs8[23:16];
-					radr <= vect;
-					vpb <= TRUE;
-//					data_read(vect);
-					im <= 1'b1;
+					pc <= {8'h00,temp_vec};//abs8[23:16];
+					iml <= 3'd7;
 					bank_wrap <= FALSE;
                     page_wrap <= FALSE;
 				end
 			end
-		default:
-			if (isJsrIndx) begin
-				load_what <= `PC_310;
-				state <= LOAD_MAC1;
-				seg <= ds_base;
-                lmt <= ds_limit;
-                mem_wr <= ds_wr;
-				radr <= ir[31:8] + x;
-				bank_wrap <= FALSE;
-                page_wrap <= FALSE;
-			end
-			else if (isJsrInd) begin
-				load_what <= `PC_310;
-				state <= LOAD_MAC1;
-				seg <= ds_base;
-                lmt <= ds_limit;
-                mem_wr <= ds_wr;
-				radr <= ir[31:8];
-				bank_wrap <= FALSE;
-                page_wrap <= FALSE;
-			end
 		endcase
 `ifdef SUPPORT_DCACHE
 		if (!dhit && write_allocate) begin
@@ -5335,6 +5153,9 @@
         `LDY_IMM,`LDY_ZP,`LDY_ZPX,`LDY_ABS,`LDY_ABSX,`LDY_XABS,`LDY_XABSX:    begin res32 <= b32; end
         `TRB_ZP,`TRB_ABS,`TRB_XABS:    begin res32 <= acc & b32; wdat <= ~acc & b32; state <= STORE1; data_nack(); end
         `TSB_ZP,`TSB_ABS,`TSB_XABS:    begin res32 <= acc & b32; wdat <= acc | b32; state <= STORE1; data_nack(); end
+        `BMT_XABS:  begin res32 <= (32'd1 << acc[2:0]) & b32; end
+        `BMS_XABS:  begin res32 <= (32'd1 << acc[2:0]) & b32; wdat <= (32'd1 << acc[2:0]) | b32; state <= STORE1; data_nack(); end
+        `BMC_XABS:  begin res32 <= (32'd1 << acc[2:0]) & b32; wdat <= ~(32'd1 << acc[2:0]) & b32; state <= STORE1; data_nack(); end
 		`INC_ZP,`INC_ZPX,`INC_ABS,`INC_ABSX,`INC_XABS,`INC_XABSX:    begin res32 <= b32 + 32'd1; wdat <= b32+32'd1; state <= STORE1; data_nack(); end
         `DEC_ZP,`DEC_ZPX,`DEC_ABS,`DEC_ABSX,`DEC_XABS,`DEC_XABSX:    begin res32 <= b32 - 32'd1; wdat <= b32-32'd1; state <= STORE1; data_nack(); end
 		`ASL_ZP,`ASL_ZPX,`ASL_ABS,`ASL_ABSX,`ASL_XABS,`ASL_XABSX:    begin res32 <= {b32,1'b0}; wdat <= {b32[30:0],1'b0}; state <= STORE1; data_nack(); end
@@ -5373,11 +5194,15 @@
 		if (m832) begin
             if (&acc) begin
                 pc <= npc;
+                if (pc[23:16]!= npc[23:16])
+                    next_state(PBDELAY);
             end
 		end
 		else begin
             if (&acc[15:0]) begin
                 pc <= npc;
+                if (pc[23:16]!= npc[23:16])
+                    next_state(PBDELAY);
                 dbr <= mvndst_bank;
             end
 		end
@@ -5387,7 +5212,7 @@
         set_task_regs(24'd0);
         otr <= tr;
         back_link <= tr; 
-        tr <= 16'd3;        // single step task
+        tr <= 16'd9;        // single step task
         tsk_pres <= 7'h2C;
         acc <= tr;
         x <= pc;
@@ -5468,11 +5293,19 @@
 input [31:0] adr;
 input first;
 begin
+`ifdef SUPPORT_SEG
     if (adr > lmt)
         seg_fault(SEGF_BOUND);
+    else
+`endif
+    if (lla) begin
+        acc <= seg + adr;
+        next_state(IFETCH);
+    end
     else begin
         vpa <= `FALSE;
-        vda <= `TRUE;
+        vda <= !cs_pgmap;
+        ivda <= `TRUE;
         rwo <= `TRUE;
         ado <= seg + adr;
 	end
@@ -5484,17 +5317,23 @@
 input [7:0] dat;
 input first;
 begin
+`ifdef SUPPORT_SEG
     if (adr > lmt)
         seg_fault(SEGF_BOUND);
-    else if (mem_wr) begin
+    else if (mem_wr)
+`endif
+    begin
         vpa <= `FALSE;
-        vda <= `TRUE;
+        vda <= !cs_pgmap;
+        ivda <= `TRUE;
         rwo <= `FALSE;
         ado <= seg + adr;
         dbo <= dat;
 	end
+`ifdef SUPPORT_SEG
 	else
 	    seg_fault(SEGF_WRITE);
+`endif
 end
 endtask
 
@@ -5502,6 +5341,7 @@
 begin
 	vpa <= `FALSE;
 	vda <= `FALSE;
+	ivda <= `FALSE;
 	rwo <= `TRUE;
 //	ado <= 32'h000000;
 //	dbo <= 8'h00;
@@ -5508,6 +5348,65 @@
 end
 endtask
 
+// RTT, RTC instructions
+task do_rtx;
+input [23:0] pcinc;
+input [7:0] spinc;
+input [7:0] tp;
+begin
+    inc_pc(pcinc);
+    if (ir9!=`RTC && ir9!=`RTIC)
+        set_task_regs(pcinc);
+    tsk_pres <= tp;
+    sp_i <= fn_add_to_sp(spinc+32'd2);
+    inc_sp();
+`ifdef SUPPORT_SEG                
+    seg <= ss_base;
+    lmt <= ss_limit;
+    mem_wr <= ss_wr;
+`endif
+    load_what <= `LDW_TR70S;
+    state <= LOAD_MAC1;
+end
+endtask
+
+task do_tsk;
+input [`TASK_MEM_ABIT-3:0] ntr;   // new task register value
+begin
+    store_what <= `STW_TR158;
+    tsk_pres <= PRES_NONE;
+    if (tr != ntr) begin
+        set_task_regs(24'd3);
+        otr <= tr;
+        tr <= ntr;
+        next_state(TSK1);
+        retstate <= tj_prefix ? IFETCH : STORE1;
+    end
+    //retstate <= ssm ? SSM1 : IFETCH;
+end
+endtask
+
+task do_fork;
+input [`TASK_MEM_ABIT-3:0] ntr;   // new task register value
+begin
+    store_what <= `STW_TR158;
+    if (tr != ntr) begin
+        set_task_regs(24'd3);
+        otr <= tr;
+        tr <= ntr;
+`ifdef SUPPORT_SEG                    
+        seg <= ss_base;
+        lmt <= ss_limit;
+        mem_wr <= ss_wr;
+`endif                    
+        if (!tj_prefix) begin
+            set_sp();
+            next_state(STORE1);
+        end
+    end
+end
+endtask
+
 task set_task_regs;
 input [23:0] amt;
 begin
@@ -5514,6 +5413,7 @@
     tskm_we <= TRUE;
     tskm_wr <= TRUE;
     tskm_wa <= tr;
+    mapno_i <= mapno;
 `ifdef SUPPORT_SEG
     cs_i <= cs;
     ds_i <= ds;
@@ -5531,8 +5431,11 @@
     x_i <= x;
     y_i <= y;
     sp_i <= sp;
-    sr_i <= sr8;
-    srx_i <= {3'b0,ssm,1'b0,mib,m832,m816};
+    if (tr==9'd1 || tr==9'd2 || tr==9'd3)
+        sr_i <= sr8|8'h04;//sr8&8'hFB;
+    else
+        sr_i <= sr8&8'hFB;
+    srx_i <= {iml,ssm,1'b0,mib,m832,m816};
     dbr_i <= dbr;
     dpr_i <= dpr;
     bl_i <= back_link;
@@ -5558,6 +5461,16 @@
 end
 endtask
 
+task set_vect_seg;
+begin
+`ifdef SUPPORT_SEG
+    seg <= 32'd0;
+    lmt <= 32'hFFFF;
+    mem_wr <= FALSE;
+`endif
+end
+endtask
+
 `include "FT832misc_task.v"
 
 task next_state;
@@ -5577,6 +5490,16 @@
 end
 endtask
 
+function fn_inc_pc;
+input [23:0] amt;
+begin
+if (PC24)
+    fn_inc_pc = pc + amt;
+else
+    fn_inc_pc = {pc[23:16],pc[15:0] + amt[15:0]};
+end
+endfunction
+
 task seg_fault;
 input [7:0] fault_num;
 begin
@@ -5610,22 +5533,21 @@
 BUS_ERROR:	fnStateName = "BUS_ERROR  ";
 LOAD_MAC1:	fnStateName = "LOAD_MAC1  ";
 LOAD_MAC2:	fnStateName = "LOAD_MAC2  ";
-LOAD_MAC3:	fnStateName = "LOAD_MAC3  ";
-LOAD_DCACHE:	fnStateName = "LOAD_DCACHE";
-LOAD_ICACHE:	fnStateName = "LOAD_ICACHE";
-LOAD_IBUF1:		fnStateName = "LOAD_IBUF1 ";
-LOAD_IBUF2:		fnStateName = "LOAD_IBUF2 ";
-LOAD_IBUF3:		fnStateName = "LOAD_IBUF3 ";
 ICACHE1:		fnStateName = "ICACHE1    ";
 ICACHE2:		fnStateName = "ICACHE2    ";
 ICACHE3:		fnStateName = "ICACHE3    ";
-IBUF1:			fnStateName = "IBUF1      ";
-DCACHE1:		fnStateName = "DCACHE1    ";
 MVN816:			fnStateName = "MVN816     ";
 TSK1:           fnStateName = "TSK1       ";
+TSK2:           fnStateName = "TSK2       ";
+TSK3:           fnStateName = "TSK3       ";
+TSK4:           fnStateName = "TSK4       ";
 LDT1:           fnStateName = "LDT1       ";
 INF1:           fnStateName = "INF1       ";
 SSM1:           fnStateName = "SSM1       ";
+JMF1:           fnStateName = "JMF1       ";
+TASS1:          fnStateName = "TASS1      ";
+PLDS1:          fnStateName = "PLDS1      ";
+PLDS2:          fnStateName = "PLDS2      ";
 default:		fnStateName = "UNKNOWN    ";
 endcase
 endfunction
@@ -5645,8 +5567,6 @@
 input rce;
 output [127:0] insn;
 reg [127:0] insn;
-
-`ifdef ICACHE_4K
 input [11:0] wa;
 input [11:0] pc;
 reg [127:0] mem [0:255];
@@ -5653,14 +5573,6 @@
 reg [11:0] rpc,rpcp16;
 wire [127:0] insn0 = mem[rpc[11:4]];
 wire [127:0] insn1 = mem[rpcp16[11:4]];
-`elsif ICACHE_16K
-input [13:0] wa;
-input [13:0] pc;
-reg [127:0] mem [0:1023];
-reg [13:0] rpc,rpcp16;
-wire [127:0] insn0 = mem[rpc[13:4]];
-wire [127:0] insn1 = mem[rpcp16[13:4]];
-`endif
 
 genvar g;
 generate
@@ -5667,11 +5579,7 @@
 begin : wstrobes
 for (g = 0; g < 16; g = g + 1)
 always @(posedge wclk)
-`ifdef ICACHE_4K
 	if (wce & wr && wa[3:0]==g) mem[wa[11:4]][g*8+7:g*8] <= i;
-`elsif ICACHE_16K
-	if (wce & wr && wa[3:0]==g) mem[wa[13:4]][g*8+7:g*8] <= i;
-`endif
 end
 endgenerate
 
@@ -5714,15 +5622,9 @@
 output hit0;
 output hit1;
 
-`ifdef ICACHE_4K
 wire [20:0] tag0,tag1;
 reg [31:12] mem [0:255];
 reg [0:255] tvalid;
-`elsif ICACHE_16K
-wire [18:0] tag0,tag1;
-reg [31:14] mem [0:1023];
-reg [0:1023] tvalid;
-`endif
 reg [31:0] rpc,rpcp16;
 
 always @(posedge rclk)
@@ -5730,7 +5632,6 @@
 always @(posedge rclk)
 	if (rce) rpcp16 <= pc + 32'd16;
 
-`ifdef ICACHE_4K
 always @(posedge wclk)
 	if (wce & wr) mem[wa[11:4]] <= wa[31:12];
 always @(posedge wclk)
@@ -5743,26 +5644,12 @@
 assign hit0 = tag0 == {rpc[31:12],1'b1};
 assign hit1 = tag1 == {rpcp16[31:12],1'b1};
 
-`elsif ICACHE_16K
-always @(posedge wclk)
-	if (wce & wr) mem[wa[13:4]] <= wa[31:14];
-always @(posedge wclk)
-        if (invalidate) tvalid <= 1024'd0;
-        else if (invalidate_line) tvalid[wa[13:4]] <= 1'b0;
-        else if (wce & wr) tvalid[wa[13:4]] <= 1'b1;
-assign tag0 = {mem[rpc[13:4]],tvalid[rpc[13:4]]};
-assign tag1 = {mem[rpcp16[13:4]],tvalid[rpcp16[13:4]]};
-
-assign hit0 = tag0 == {rpc[31:14],1'b1};
-assign hit1 = tag1 == {rpcp16[31:14],1'b1};
-`endif
-
 endmodule
 
 module task_mem(wclk, wce, wr, wa,
-    cs_i, ds_i, ss_i, pc_i, acc_i, x_i, y_i, sp_i, sr_i, srx_i, db_i, dpr_i, bl_i,
+    cs_i, ds_i, ss_i, pc_i, acc_i, x_i, y_i, sp_i, sr_i, srx_i, db_i, dpr_i, bl_i, mapno_i,
     rclk, rce, ra,
-    cs_o, ds_o, ss_o, pc_o, acc_o, x_o, y_o, sp_o, sr_o, srx_o, db_o, dpr_o, bl_o
+    cs_o, ds_o, ss_o, pc_o, acc_o, x_o, y_o, sp_o, sr_o, srx_o, db_o, dpr_o, bl_o, mapno_o,
 );
 input wclk;
 input wce;
@@ -5780,7 +5667,8 @@
 input [7:0] srx_i;
 input [7:0] db_i;
 input [15:0] dpr_i;
-input [`TASK_MEM_ABIT:0] bl_i;
+input [5:0] mapno_i;
+input [`TASK_MEM_ABIT-3:0] bl_i;
 input rclk;
 input rce;
 input [`TASK_MEM_ABIT:0] ra;
@@ -5796,12 +5684,13 @@
 output [7:0] srx_o;
 output [7:0] db_o;
 output [15:0] dpr_o;
-output [`TASK_MEM_ABIT:0] bl_o;
-reg [`TASK_MEM_ABIT+240:0] mem [`TASK_MEM-1:0];
+output [5:0] mapno_o;
+output [`TASK_MEM_ABIT-3:0] bl_o;
+reg [`TASK_MEM_ABIT+246-3:0] mem [`TASK_MEM-1:0];
 always @(posedge wclk)
     if (wce & wr)
-        mem[wa] <= {bl_i,cs_i,ds_i,ss_i,pc_i,acc_i,x_i,y_i,sp_i,sr_i,srx_i,db_i,dpr_i};
-wire [`TASK_MEM_ABIT+240:0] memo;
+        mem[wa] <= {bl_i,mapno_i,cs_i,ds_i,ss_i,pc_i,acc_i,x_i,y_i,sp_i,sr_i,srx_i,db_i,dpr_i};
+wire [`TASK_MEM_ABIT+246-3:0] memo;
 reg [`TASK_MEM_ABIT:0] rra;
 always @(posedge rclk)
     rra <= ra;
@@ -5818,7 +5707,8 @@
 assign ss_o = memo[207:192];
 assign ds_o = memo[223:208];
 assign cs_o = memo[239:224];
-assign bl_o = memo[`TASK_MEM_ABIT+240:240];
+assign mapno_o = memo[245:240];
+assign bl_o = memo[`TASK_MEM_ABIT+246-3:246];
 
 endmodule
 
@@ -5839,6 +5729,12 @@
 
 reg [43:0] mem [4095:0];
 reg [11:0] rra;
+integer n;
+initial begin
+    for (n = 0; n < 4096; n = n + 1)
+        mem[n] = 0;
+end
+
 always @(posedge wclk)
     if (wce & wr) mem[wa] <= {acr_i,size_i,base_i};
 always @(posedge rclk)
@@ -5848,3 +5744,33 @@
 assign base_o = mem[rra][31:0];
 
 endmodule
+/*
+module ProgramMappingTbl(clk, wr, wadr, wdat, rdat, omapno, pb, page);
+input clk;
+input wr;
+input [14:0] wadr;
+input [7:0] wdat;
+output [7:0] rdat;
+input [5:0] omapno;
+input [7:0] pb;
+output [12:0] page;
+
+reg [12:0] mem [0:16384];
+reg [13:0] rradr;
+reg [14:0] rradr1;
+
+always @(posedge clk)
+begin
+    if (wr & ~wadr[0]) mem[wadr[14:1]][7:0] <= wdat;
+    if (wr &  wadr[0]) mem[wadr[14:1]][12:8] <= wdat[4:0];
+end
+
+always @(posedge clk)
+    rradr1 <= wadr[14:0];
+always @(posedge clk)
+    rradr <= {omapno,pb};
+assign page = (omapno==6'd0) ? pb : mem [rradr];
+assign rdat = rradr1[0] ? mem[rradr1[14:1]][12:8] : mem[rradr1[14:1]][7:0];
+
+endmodule
+*/
Index: ultimate_cart/veronica/byte_calc.v
===================================================================
--- ultimate_cart/veronica/byte_calc.v	(revision 684)
+++ ultimate_cart/veronica/byte_calc.v	(revision 685)
@@ -38,8 +38,8 @@
 		`LDY_IMM,`LDY_ZP,`LDY_ZPX,`LDY_ABS,`LDY_ABSX:	begin res8 <= b8; end
 		`CPX_IMM,`CPX_ZP,`CPX_ABS:	begin res8 <= x8 - b8; end
 		`CPY_IMM,`CPY_ZP,`CPY_ABS:	begin res8 <= y8 - b8; end
-		`TRB_ZP,`TRB_ABS:	begin res8 <= ~acc8 & b8; wdat <= ~acc8 & b8; state <= STORE1; data_nack(); end
-		`TSB_ZP,`TSB_ABS:	begin res8 <= acc8 | b8; wdat <= acc8 | b8; state <= STORE1; data_nack(); end
+		`TRB_ZP,`TRB_ABS:	begin res8 <= acc8 & b8; wdat <= ~acc8 & b8; state <= STORE1; data_nack(); end
+		`TSB_ZP,`TSB_ABS:	begin res8 <= acc8 & b8; wdat <= acc8 | b8; state <= STORE1; data_nack(); end
 		`ASL_ZP,`ASL_ZPX,`ASL_ABS,`ASL_ABSX:	begin res8 <= {b8,1'b0}; wdat <= {b8[6:0],1'b0}; state <= STORE1; data_nack(); end
 		`ROL_ZP,`ROL_ZPX,`ROL_ABS,`ROL_ABSX:	begin res8 <= {b8,cf}; wdat <= {b8[6:0],cf}; state <= STORE1; data_nack(); end
 		`LSR_ZP,`LSR_ZPX,`LSR_ABS,`LSR_ABSX:	begin res8 <= {b8[0],1'b0,b8[7:1]}; wdat <= {1'b0,b8[7:1]}; state <= STORE1; data_nack(); end
Index: ultimate_cart/veronica/load_mac.v
===================================================================
--- ultimate_cart/veronica/load_mac.v	(revision 684)
+++ ultimate_cart/veronica/load_mac.v	(revision 685)
@@ -43,7 +43,8 @@
 LOAD_MAC2:
 	if (rdy) begin
 		data_nack();
-		load_tsk(db);
+`include "load_tsk.v"
+//		load_tsk(db,b16);
 	end
 `ifdef SUPPORT_BERR
 	else if (err_i) begin
Index: ultimate_cart/veronica/load_tsk.v
===================================================================
--- ultimate_cart/veronica/load_tsk.v	(revision 684)
+++ ultimate_cart/veronica/load_tsk.v	(revision 685)
@@ -20,8 +20,8 @@
 //                                                                          
 // ============================================================================
 //
-task load_tsk;
-input [7:0] db;
+//task load_tsk;
+//input [7:0] db;
 begin
 	case(load_what)
 	`BYTE_70:
@@ -202,4 +202,4 @@
 			end
 	endcase
 end
-endtask
+//endtask
